SystemOrganization addCategory: #'Khami-Core'!
SystemOrganization addCategory: #'Khami-Core-Support'!

Object subclass: #KmGame
	instanceVariableNames: 'tilePool players board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmGame class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/9/2011 18:40'!
testGame
	^self basicNew
		initializeWithTilePool: KmTile testSet;
		yourself! !

!KmGame methodsFor: 'initialization' stamp: 'StuartHerring 1/12/2011 19:33'!
board
	^board! !

!KmGame methodsFor: 'initialization' stamp: 'StuartHerring 1/12/2011 19:35'!
initializeWithTilePool: aPool
	self initialize.
	tilePool := aPool.
	board := KmGameBoard new.! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:26'!
remainingTiles
	^tilePool! !

Object subclass: #KmGameBoard
	instanceVariableNames: 'board startingTile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:47'!
at: row at: column
	^board at: row at: column! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:38'!
columns
	^board columns! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:49'!
initialize
	super initialize.
	startingTile := KmTile startingTile.
	board := KmGrid ofSize: 3 by: 3.
	board at: 2 at: 2 put: startingTile! !

!KmGameBoard methodsFor: 'testing' stamp: 'StuartHerring 1/16/2011 09:52'!
isAvailableAt: row at: column
	(board at: row at: column) ifNotNil: [^false].
	(row  > 1) ifTrue: [(board at: row - 1 at: column) ifNotNil: [^true]].
	(row < board rows) ifTrue: [(board at: row + 1 at: column) ifNotNil: [^true]]. 
	(column  > 1) ifTrue: [(board at: row at: column - 1) ifNotNil: [^true]].
	(column < board columns) ifTrue: [(board at: row at: column + column) ifNotNil: [^true]]. 
	^false
	! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:38'!
rows
	^board rows! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:46'!
startingTile
	^startingTile! !

Object subclass: #KmGrid
	instanceVariableNames: 'rows cols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core-Support'!

!KmGrid class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 14:30'!
ofSize: rows by: columns
	^self new
		addColumns: columns;
		addRows: rows;
		yourself.! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 14:28'!
addColumns: aNumber
	rows do:  [:row |
		aNumber timesRepeat: [ row add: nil ]].
	cols := cols + aNumber.
		! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 14:07'!
addRows: aNumber
	aNumber timesRepeat:  [
		rows add: (OrderedCollection ofSize: cols)]! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/13/2011 15:42'!
adjacentItemsAt: row at: column
! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 09:44'!
at: row at: column
	^(rows at: row) at: column ! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 11:11'!
at: row at: column put: data
	(rows at: row) at: column put: data! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 11:59'!
columns
	^cols! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 12:12'!
initialize
	super initialize.
	rows := OrderedCollection new.
	cols := 0.! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 11:59'!
rows
	^rows size! !

Object subclass: #KmLocation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmLocation subclass: #Bottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Bottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:18'!
opposite
	^Top! !

KmLocation subclass: #Centre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Centre class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:21'!
opposite
	self shouldNotImplement! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:22'!
edges
	^{Top. Right. Bottom. Left.}! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
opposite
	^self subclassResponsibility! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:22'!
pathLocations
	^{Top. Right. Bottom. Left. Centre}! !

KmLocation subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Left class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite 
	^Right! !

KmLocation subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Right class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite
	^Left! !

KmLocation subclass: #Top
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Top class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite
	^Bottom! !

Object subclass: #KmPiece
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmPiece class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/7/2011 15:07'!
forPlayer: aPlayer
	^self basicNew
		initializeWithPlayer: aPlayer;
		yourself! !

!KmPiece methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2011 15:06'!
initializeWithPlayer: aPlayer
	self initialize.
	player := aPlayer! !

Object subclass: #KmPlayer
	instanceVariableNames: 'pieces colour name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

Object subclass: #KmTile
	instanceVariableNames: 'regions paths orientation regionMap pathMap tiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 09:39'!
buildTileSet: aCollection
	^aCollection collect: [ :string | self fromString: string ]! !

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/9/2011 10:10'!
fromString: aString
	^self new
		buildFromStream: (ReadStream on: aString);
		yourself! !

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 09:39'!
startingTile
	^self fromString: 'VFFF.-.--'! !

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/9/2011 18:23'!
testSet
	^self buildTileSet: {
		'VVFF.....'.
		'FFFF--..-'.
		'FFFF----.'.
		'FFFV.-...'.
	}! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 17:24'!
buildFromStream: aStream
	1 to: 4 do: [ :i | |char|
		char := aStream next.
		regions at: (i * 2 - 1) put: (KmRegion fromChar: char ).
		regions at: (i * 2) put: (KmRegion fromChar: char )
	].
	1 to: 5 do: [ :i | paths at: i put: (KmPath fromChar: aStream next)]! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/12/2011 13:09'!
initialize
	super initialize.
	orientation := 0.
	tiles := Dictionary new.
	regions := ((0 to: 7) collect: [ :x | KmFarmRegion new ]) asArray.
	paths := ((0 to: 5) collect: [ :x | KmTerminatorPath new ]) asArray.
	regionMap := Dictionary new.
	#(#topLeft #topRight #rightTop #rightBottom #bottomRight #bottomLeft #leftBottom #leftTop)
		keysAndValuesDo: [ :index :symbol | regionMap at: symbol put: index ].
	pathMap := Dictionary new.
	#(#top #right #bottom #left #centre) keysAndValuesDo: [ :index :symbol | pathMap at: symbol put: index ]! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/7/2011 16:20'!
orientation 
	^orientation! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/7/2011 16:21'!
orientation: aNumber
	(aNumber < 0 or: [ aNumber > 3]) ifTrue: [
		self error: 'Orientation Must be a number between 0 and 3, was: ', aNumber displayString ].
	orientation := aNumber! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:00'!
pathAt: aSymbol
	^paths at: (pathMap at: aSymbol)! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 17:58'!
regionAt: aSymbol
	^regions at: (regionMap at: aSymbol)! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:10'!
tileAt: aDirection
	^tiles at: aDirection ifAbsent: [nil]! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:25'!
tileAt: aDirection put: aTile
	tiles at: aDirection ifAbsent: [
		tiles at: aDirection put: aTile.
		aTile tileAt: aDirection opposite put: self
	]! !

Object subclass: #KmTileSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmTileSegment subclass: #KmPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmPath class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:50'!
isAbstract 
	^self = KmPath! !

KmPath subclass: #KmRoadPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmRoadPath class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:59'!
codeCharacter
	^$-! !

!KmRoadPath methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:58'!
isRoad
	^true! !

KmPath subclass: #KmTerminatorPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmTerminatorPath class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:59'!
codeCharacter
	^$.! !

!KmTerminatorPath methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:11'!
isTerminator
	^true! !

KmTileSegment subclass: #KmRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmRegion subclass: #KmFarmRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmFarmRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:42'!
codeCharacter
	^$F! !

!KmFarmRegion methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:10'!
isFarm
	^true! !

!KmRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:51'!
isAbstract
	^self = KmRegion! !

KmRegion subclass: #KmVillageRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmVillageRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:42'!
codeCharacter
	^$V! !

!KmVillageRegion methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:11'!
isVillage
	^true! !

!KmTileSegment class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:49'!
codeCharacter
	self subclassResponsibility! !

!KmTileSegment class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 23:10'!
fromChar: aChar
	^(self allSubclasses detect: [ :class | 
		(class isAbstract not) and: [class codeCharacter = aChar]]) new! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:59'!
isFarm 
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 17:15'!
isRoad
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:58'!
isTerminator 
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:59'!
isVillage 
	^false! !
